#line 994 "../../src/builtin/snarf.m4"
/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 994
#ifdef HAVE_CONFIG_H
#line 994
# include <config.h>
#line 994
#endif
#line 994
#include <sys/types.h>
#line 994

#line 994
#include "mailfromd.h"
#line 994
#include "prog.h"
#line 994
#include "builtin.h"
#line 994

#line 994

#line 1034 "../../src/builtin/snarf.m4"

/* End of snarf.m4 */
#line 1 "mfmod.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2022 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */


#ifdef WITH_MFMOD
#line 18


#include <mflib/status.h>
#include "global.h"
#include "mfmod.h"
#include "msg.h"
#include <dlfcn.h>
#include <mailutils/wordsplit.h>

static size_t nmfmods = MAX_MFMODS;
char *mfmod_path = MFMODDIR;
static struct mu_cfg_param mfmod_cfg_param[] = {
	{ "max-mfmods", mu_c_size, &nmfmods, 0, NULL,
	  N_("Maximum number of dynamically loaded modules.") },
	{ "mfmod-path", mu_c_string, &mfmod_path, 0, NULL,
	  N_("Search path for dynamically loaded modules.") },
	{ NULL }
};

struct modinfo {
	void *handle;
	char *libname;
	char *symname;
	MFMOD_PARAM retval;
};

static void
mfmod_retval_free(struct modinfo *mod)
{
	if (mod->symname) {
		switch (mod->retval.type) {
		case mfmod_string:
			free(mod->retval.string);
			break;
		case mfmod_number:
		case mfmod_message: /*FIXME*/
			break;
		}
		memset(&mod->retval, 0, sizeof(mod->retval));
		free(mod->symname);
		mod->symname = NULL;
	}
}

static inline int
mfmod_is_used(struct modinfo *dltab, int i)
{
	return i >= 0 && i < nmfmods && dltab[i].handle != NULL;
}


static void *
alloc_mfmods(void)
{
	return mu_calloc(nmfmods, sizeof(struct modinfo));
}

static struct modinfo *dltab;

#if 0
// See FIXME below

static void
mfmod_close(struct modinfo *mod)
{
	mfmod_retval_free(mod);
	dlclose(mod->handle);
	free(mod->libname);
	memset(mod, 0, sizeof(*mod));
}

static void
destroy_mfmods(void)
{
	if (dltab) {
		size_t i;
		for (i = 0; i < nmfmods; i++) {
			if (mfmod_is_used(dltab, i))
				mfmod_close(&dltab[i]);
		}
		free(dltab);
	}
}
#endif

static struct modinfo *
get_dltab(void)
{
	if (!dltab) {
		dltab = alloc_mfmods();
		/*
		 * FIXME: Used to have atexit(destroy_mfmods) here.
		 * However, shutdown handlers, that are currently run
		 * via mu_onexit (i.e. atexit) as well get executed after
		 * destroy_mfmod, which causes trouble.
		 * I guess it's OK not to close dlhandles, since we're
		 * going to exit anyway.
		 */
	}
	return dltab;
}

static int
find_free_slot(struct modinfo *dltab)
{
	int i;
	for (i = 0; i < nmfmods; i++)
		if (!mfmod_is_used(dltab, i))
			return i;
	return -1;
}

static char *
mfmod_find(char const *name)
{
	char *retval = NULL;

	if (name[0] == '/')
		retval = mu_strdup(name);
	else {
		struct mu_wordsplit ws;
		size_t i;
	
		ws.ws_delim = ":";
		if (mu_wordsplit(mfmod_path, &ws, MU_WRDSF_DELIM|WRDSF_NOCMD|WRDSF_NOVAR)) {
			mu_error("can't split mfmod_path: %s", mu_wordsplit_strerror(&ws));
			mu_wordsplit_free(&ws);
			return NULL;
		}
		
		for (i = 0; i < ws.ws_wordc; i++) {
			char *libname = mu_make_file_name(ws.ws_wordv[0], name);
			if (access(libname, X_OK) == 0) {
				retval = libname;
				break;
			}
			free(libname);
		}
		mu_wordsplit_free(&ws);
	}
	return retval;
}

void
#line 161
bi_dlopen(eval_environ_t env)
#line 161

#line 161

#line 161 "mfmod.bi"
{
#line 161
	
#line 161

#line 161
        char *  libname;
#line 161
        
#line 161

#line 161
        get_string_arg(env, 0, &libname);
#line 161
        
#line 161
        adjust_stack(env, 1);
#line 161

#line 161

#line 161
	if (builtin_module_trace(BUILTIN_IDX_mfmod))
#line 161
		prog_trace(env, "dlopen %s",libname);;
#line 161

{
	struct modinfo *dltab = get_dltab();
	long n = find_free_slot(dltab);
	void *dlh;
	char *filename;
	
		if (!(n != -1))
#line 168
		(
#line 168
	env_throw_bi(env, mfe_failure, "dlopen", _("no more library slots available"))
#line 168
)
;
	filename = mfmod_find(libname);
		if (!(filename != NULL))
#line 171
		(
#line 171
	env_throw_bi(env, mfe_failure, "dlopen", _("module file %s not found in mfmod_path"),libname)
#line 171
)
#line 173
;
	env_function_cleanup_add(env, CLEANUP_ALWAYS, filename, free);
	dlh = dlopen(filename, RTLD_LAZY | RTLD_LOCAL);
		if (!(dlh != NULL))
#line 176
		(
#line 176
	env_throw_bi(env, mfe_failure, "dlopen", _("can't load %s: %s"),libname,dlerror())
#line 176
)
;
	dltab[n].handle = dlh;
	dltab[n].libname = mu_strdup(libname);
	
#line 180
do {
#line 180
  push(env, (STKVAL)(mft_number)(n));
#line 180
  goto endlab;
#line 180
} while (0);
}
endlab:
#line 182
        env_function_cleanup_flush(env, CLEANUP_RETURN);
#line 182
	return;
#line 182
}

static void
_cleanup_vparam(void *ptr)
{
	free(ptr);
}

static void
_cleanup_retval(void *ptr)
{
	struct modinfo *mod = ptr;
	free(mod->retval.string);
	mod->retval.string = NULL;
}

void
#line 198
bi_dlcall(eval_environ_t env)
#line 198

#line 198

#line 198 "mfmod.bi"
{
#line 198
	
#line 198

#line 198
        long  dlh;
#line 198
        char *  symname;
#line 198
        char *  types;
#line 198
        
#line 198
        long __bi_argcnt;
#line 198
        get_numeric_arg(env, 0, &__bi_argcnt);
#line 198
        get_numeric_arg(env, 1, &dlh);
#line 198
        get_string_arg(env, 2, &symname);
#line 198
        get_string_arg(env, 3, &types);
#line 198
        
#line 198
        adjust_stack(env, __bi_argcnt + 1);
#line 198

#line 198

#line 198
	if (builtin_module_trace(BUILTIN_IDX_mfmod))
#line 198
		prog_trace(env, "dlcall %lu %s %s",dlh, symname, types);;
#line 198

{
	long i;
	MFMOD_FUNC func;
	struct modinfo *dltab = get_dltab();
	struct modinfo *mod;
	size_t nparam;
	MFMOD_PARAM *vparam;
	int rc;
	
		if (!(mfmod_is_used(dltab, dlh)))
#line 208
		(
#line 208
	env_throw_bi(env, mfe_failure, "dlcall", _("invalid dynamic library handle"))
#line 208
)
#line 210
;
	mod = &dltab[dlh];

	mfmod_retval_free(mod);
	dlerror(); /* Clear error state */
	func = dlsym(mod->handle, symname);
	if (!func) {
		char *err = dlerror();
		if (err)
			(
#line 219
	env_throw_bi(env, mfe_failure, "dlcall", _("can't find symbol %s in %s: %s"),symname,mod->libname,err)
#line 219
);
#line 221
		else
			(
#line 222
	env_throw_bi(env, mfe_failure, "dlcall", _("%s in module %s has NULL value"),symname,mod->libname)
#line 222
);
#line 224
	}

	nparam = (__bi_argcnt - 3);
		if (!(nparam == strlen(types)))
#line 227
		(
#line 227
	env_throw_bi(env, mfe_failure, "dlcall", _("number of arguments doesn't satisfy type string"))
#line 227
)
#line 229
;

	vparam = mu_calloc(nparam, sizeof(vparam[0]));
	env_function_cleanup_add(env, CLEANUP_ALWAYS, vparam, _cleanup_vparam);

	
#line 234
unroll_stack(env, __bi_argcnt + 1);
	for (i = 0; i < nparam; i++) {
		switch (types[i]) {
		case 'n':
		case 'i':
		case 'd':
			vparam[i].type = mfmod_number;
			
#line 241
 ((__bi_argcnt > (i+3)) ?   get_numeric_arg(env, (i+3) + 1, &vparam[i].number) :   ((
#line 241
	env_throw_bi(env, mfe_range, "dlcall", "Argument %u is not supplied",(unsigned) (i+3))
#line 241
),(long ) 0));
			break;

		case 's':
			vparam[i].type = mfmod_string;
			
#line 246
 ((__bi_argcnt > (i+3)) ?   get_string_arg(env, (i+3) + 1, &vparam[i].string) :   ((
#line 246
	env_throw_bi(env, mfe_range, "dlcall", "Argument %u is not supplied",(unsigned) (i+3))
#line 246
),(char * ) 0));
			break;

		case 'm': {
			long n;
			mu_message_t msg;
			
			
#line 253
 ((__bi_argcnt > (i+3)) ?   get_numeric_arg(env, (i+3) + 1, &n) :   ((
#line 253
	env_throw_bi(env, mfe_range, "dlcall", "Argument %u is not supplied",(unsigned) (i+3))
#line 253
),(long ) 0));
			msg = bi_message_from_descr(env, n);
			vparam[i].type = mfmod_message;
			vparam[i].message = msg;
			break;
		}
				
		default:
			(
#line 261
	env_throw_bi(env, mfe_failure, "dlcall", "unrecognized data type in %s at position: %ld",types,i)
#line 261
);
#line 264
		}
	}
	adjust_stack(env, __bi_argcnt + 1);

	rc = func(nparam, vparam, &mod->retval);
	if (rc < 0) {
		(
#line 270
	env_throw_bi(env, mfe_failure, "dlcall", _("call to %s in module %s failed"),symname,mod->libname)
#line 270
);
#line 273
	} else if (rc) {
		if (mod->retval.type == mfmod_string && mod->retval.string) {
			env_function_cleanup_add(env, CLEANUP_THROW, mod, _cleanup_retval);
			(
#line 276
	env_throw_bi(env, rc, "dlcall", _("call to %s in module %s failed: %s"),symname,mod->libname,mod->retval.string)
#line 276
);
#line 279
		} else {
			(
#line 280
	env_throw_bi(env, rc, "dlcall", _("call to %s in module %s failed"),symname,mod->libname)
#line 280
);
#line 283
		}
	}
	mod->symname = mu_strdup(symname);
}

#line 287
        env_function_cleanup_flush(env, CLEANUP_RETURN);
#line 287
	return;
#line 287
}

static void
dlreturn(eval_environ_t env, int dlh, int type)
{
	struct modinfo *dltab = get_dltab();

		if (!(mfmod_is_used(dltab, dlh)))
#line 294
		(
#line 294
	env_throw_bi(env, mfe_failure, NULL, _("invalid dynamic library handle"))
#line 294
)
#line 296
;
		if (!(dltab[dlh].symname != NULL))
#line 297
		(
#line 297
	env_throw_bi(env, mfe_failure, NULL, _("no return value from the recent call in %s"),dltab[dlh].libname)
#line 297
)
#line 300
;
		if (!(dltab[dlh].retval.type == type))
#line 301
		(
#line 301
	env_throw_bi(env, mfe_failure, NULL, _("type mismatch in return from %s, library %s"),dltab[dlh].symname,dltab[dlh].libname)
#line 301
)
#line 304
;
	switch (dltab[dlh].retval.type) {
	case mfmod_number:
		push(env, (STKVAL)(mft_number)dltab[dlh].retval.number);
		break;

	case mfmod_string:
		pushs(env, dltab[dlh].retval.string);
		break;

	case mfmod_message: {
		int rc;
		
		rc = bi_message_register(env, NULL, dltab[dlh].retval.message, MF_MSG_STANDALONE);
		if (rc < 0) {
			mu_message_destroy(&dltab[dlh].retval.message, mu_message_get_owner(dltab[dlh].retval.message));
			(
#line 320
	env_throw_bi(env, mfe_failure, NULL, _("no more message slots available"))
#line 320
);
#line 322
		}
		push(env, (STKVAL)(mft_number)rc);
	}
	}
	mfmod_retval_free(&dltab[dlh]);
}

void
#line 329
bi_dlresult_string(eval_environ_t env)
#line 329

#line 329

#line 329 "mfmod.bi"
{
#line 329
	
#line 329

#line 329
        long  dlh;
#line 329
        
#line 329

#line 329
        get_numeric_arg(env, 0, &dlh);
#line 329
        
#line 329
        adjust_stack(env, 1);
#line 329

#line 329

#line 329
	if (builtin_module_trace(BUILTIN_IDX_mfmod))
#line 329
		prog_trace(env, "dlresult_string %lu",dlh);;
#line 329

{
	dlreturn(env, dlh, mfmod_string);
}

#line 333
        env_function_cleanup_flush(env, CLEANUP_RETURN);
#line 333
	return;
#line 333
}

void
#line 335
bi_dlresult_number(eval_environ_t env)
#line 335

#line 335

#line 335 "mfmod.bi"
{
#line 335
	
#line 335

#line 335
        long  dlh;
#line 335
        
#line 335

#line 335
        get_numeric_arg(env, 0, &dlh);
#line 335
        
#line 335
        adjust_stack(env, 1);
#line 335

#line 335

#line 335
	if (builtin_module_trace(BUILTIN_IDX_mfmod))
#line 335
		prog_trace(env, "dlresult_number %lu",dlh);;
#line 335

{
	dlreturn(env, dlh, mfmod_number);
}

#line 339
        env_function_cleanup_flush(env, CLEANUP_RETURN);
#line 339
	return;
#line 339
}

void
#line 341
bi_dlresult_message(eval_environ_t env)
#line 341

#line 341

#line 341 "mfmod.bi"
{
#line 341
	
#line 341

#line 341
        long  dlh;
#line 341
        
#line 341

#line 341
        get_numeric_arg(env, 0, &dlh);
#line 341
        
#line 341
        adjust_stack(env, 1);
#line 341

#line 341

#line 341
	if (builtin_module_trace(BUILTIN_IDX_mfmod))
#line 341
		prog_trace(env, "dlresult_message %lu",dlh);;
#line 341

{
	dlreturn(env, dlh, mfmod_message);
}

#line 345
        env_function_cleanup_flush(env, CLEANUP_RETURN);
#line 345
	return;
#line 345
}

 
#line 994 "../../src/builtin/snarf.m4"

#line 994

#line 994
#endif /* WITH_MFMOD */
#line 994

#line 994
void
#line 994
mfmod_init_builtin(void)
#line 994
{
#line 994
	
#line 994
#ifdef WITH_MFMOD
#line 994
	pp_define("WITH_MFMOD");
#line 994
	#line 161 "mfmod.bi"
va_builtin_install_ex("dlopen", bi_dlopen, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 198 "mfmod.bi"
va_builtin_install_ex("dlcall", bi_dlcall, 0, dtype_unspecified, 3, 0, 0|MFD_BUILTIN_VARIADIC|MFD_BUILTIN_NO_PROMOTE, dtype_number, dtype_string, dtype_string);
#line 329 "mfmod.bi"
va_builtin_install_ex("dlresult_string", bi_dlresult_string, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 335 "mfmod.bi"
va_builtin_install_ex("dlresult_number", bi_dlresult_number, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 341 "mfmod.bi"
va_builtin_install_ex("dlresult_message", bi_dlresult_message, 0, dtype_number, 1, 0, 0|0, dtype_number);

#line 994 "../../src/builtin/snarf.m4"
	
#line 994
	 mf_add_runtime_params(mfmod_cfg_param);
#line 994
	 
#line 994
#endif /* WITH_MFMOD */
#line 994
}
#line 994 "../../src/builtin/snarf.m4"

